import { nanoid } from 'nanoid';
import { C as CastAttribute } from '../shared/pinia-orm.744f3bbe.mjs';

class UidCast extends CastAttribute {
  /**
   * Create a new String attribute instance.
   */
  constructor(attributes) {
    super(attributes);
  }
  /**
   * Make the value for the attribute.
   */
  set(value) {
    return value ?? nanoid();
  }
}

function Uid() {
  return (target, propertyKey) => {
    const self = target.$self();
    self.setCast(propertyKey, UidCast);
    self.setRegistry(propertyKey, () => self.uid());
  };
}

export { Uid, UidCast };
