'use strict';

const nonSecure = require('nanoid/non-secure');
const CastAttribute = require('../shared/pinia-orm.2155f08d.cjs');

class UidCast extends CastAttribute.CastAttribute {
  /**
   * Create a new String attribute instance.
   */
  constructor(attributes) {
    super(attributes);
  }
  /**
   * Make the value for the attribute.
   */
  set(value) {
    return value ?? nonSecure.nanoid();
  }
}

function Uid() {
  return (target, propertyKey) => {
    const self = target.$self();
    self.setCast(propertyKey, UidCast);
    self.setRegistry(propertyKey, () => self.uid());
  };
}

exports.Uid = Uid;
exports.UidCast = UidCast;
